#ifndef EVAL_LINEAR_H
#define EVAL_LINEAR_H

#include "eval_op.h"

typedef std::map<std::string, std::shared_ptr<eval_op>> eval_op_proto_map;

class eval_linear: public eval_op {
    tensor value_;
    std::shared_ptr<eval_op> clone(const expression &expr) override;
public:
    eval_linear () {}
    eval_linear(const expression &expr);
    void eval(vars_type &variables, const kwargs_type &kwargs) override;
    static void store_prototype(eval_op_proto_map &proto_map) {
        assert(proto_map.find("Linear") == proto_map.end());
        proto_map["Linear"] = std::make_shared<eval_linear>(); // where is expr?
    }
private:
    tensor weight; // Add weight tensor
    tensor bias;   // Add bias tensor
}; // class eval_linear

#endif