#ifndef EVAL_RELU_H
#define EVAL_RELU_H

#include "eval_op.h"

typedef std::map<std::string, std::shared_ptr<eval_op>> eval_op_proto_map;

class eval_relu: public eval_op {
    tensor value_;
    std::shared_ptr<eval_op> clone(const expression &expr) override;
public:
    eval_relu () {}
    eval_relu(const expression &expr);
    void eval(vars_type &variables, const kwargs_type &kwargs) override;
    static void store_prototype(eval_op_proto_map &proto_map) {
        assert(proto_map.find("ReLU") == proto_map.end());
        proto_map["ReLU"] = std::make_shared<eval_relu>(); // where is expr?
    }
}; // class eval_relu

#endif